--- old/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas.c	2014-12-22 09:51:44.315386971 -0500
+++ new/usr/src/uts/common/io/scsi/adapters/mpt_sas/mptsas.c	2014-12-22 09:51:44.326369496 -0500
@@ -9854,6 +9854,26 @@
 				    "after fault was detected");
 			}
 		}
+		
+		/*
+		 * If we set the "please reset me" flag, then reset.
+		 */
+		if (mpt->m_softstate & MPTSAS_SS_RESET_INWATCH) {
+			doorbell = ddi_get32(mpt->m_datap,
+			    &mpt->m_reg->Doorbell);
+			mptsas_log(mpt, CE_WARN, "MPT Forced Reset, "
+			    "doorbell: %04x", doorbell);
+			mpt->m_softstate &= ~MPTSAS_SS_MSG_UNIT_RESET;
+			if (mpt->m_softstate & MPTSAS_SS_MUR_INWATCH)
+				mpt->m_softstate |= MPTSAS_SS_MSG_UNIT_RESET;
+			mpt->m_softstate &= ~(MPTSAS_SS_RESET_INWATCH|
+			    MPTSAS_SS_MUR_INWATCH);
+			if ((mptsas_restart_ioc(mpt)) == DDI_FAILURE) {
+				mptsas_log(mpt, CE_WARN, "Reset failed"
+				    "after fault was detected");
+			}
+		}
+		
 
 		/*
 		 * For now, always call mptsas_watchsubr.
